Estimate::Estimate(const model0, const data0, const n1, const n2, const n3)
{
	model = model0;
	data = data0;
	N1 = n1;
	N2 = n2;
	N3 = n3;
}

Estimate::Floglik(const vP, const adFunc, const avScore, const amHessian)
{
    model.ModifyLambda(exp(vP[0]));
    model.ModifyMu1(exp(vP[1]));
    model.ModifyMu2(exp(vP[1])+exp(vP[2]));
    model.ModifySigma(exp(vP[3]));
    model.ModifyDelta(exp(vP[4]));
    model.ModifyPie(exp(vP[5])./(1+exp(vP[5])));

	decl u = data.GetUnemployment();
	
    adFunc[0] = N1 .* Loglik1() + N2 .* Loglik2()
               + N3 .*(u .* log(model.Puu()) + (1-u) .* log(1-
			   		model.Puu()));
	return 1;
}

Estimate::DoEstimate(const result)
{
	decl dfunc, avscore;

	decl lambda = model.GetLambda();
	decl delta = model.GetDelta();
	decl sigma = model.GetSigma();
	decl mu1 = model.GetMu1();
	decl mu2 = model.GetMu2();
	decl pie = model.GetPie();
	decl start = log(lambda|mu1)|log(mu2-mu1)|log(sigma|delta)|
                                (log(pie)-log(1-pie));

	MaxControl(-1,1);
	QPEPS(1, 1);
	   
	decl ir = MaxBFGS(Floglik, &start, &dfunc, &avscore, TRUE);

	lambda = model.GetLambda();
	delta = model.GetDelta();
	sigma = model.GetSigma();
	mu1 = model.GetMu1();
	mu2 = model.GetMu2();
	pie = model.GetPie();
	
		
	result[0] = lambda|delta|mu1|mu2|sigma|pie;
	
	return 1;
}

Estimate::Loglik1()
{
	decl durations, frequency;
	data.GetDurations(&durations, &frequency);
    decl v  = frequency;
    decl t  = 0|durations;
	

    decl prob = (model.Psit(t[0:rows(t)-3])
				-model.Psit(t[1:rows(t)-2])
                |model.Psit(t[rows(t)-1]));
	
    return v' * log(prob);
}

Estimate::Loglik2()
{
    decl freq, wage, prob;
	data.GetWages(&wage, &freq);

    wage = 0|wage;

    prob = (model.Gie(wage[1:rows(wage)-2])-model.Gie(wage[0:rows(wage)-3]))|
                (1-model.Gie(wage[rows(wage)-1]));
    return freq' * log(prob);
}
